# GridFire: gridfire::FileDefinedEngineView Class Reference

Loading...
Searching...
No Matches
gridfire::FileDefinedEngineView Class Referencefinal

`#include <engine_defined.h>`

Inheritance diagram for gridfire::FileDefinedEngineView:

## Public Member Functions

| FileDefinedEngineView (DynamicEngine &baseEngine, const std::string &fileName, const io::NetworkFileParser &parser)
| FileDefinedEngineView Implementation ///.
std::string | getNetworkFile () const
const io::NetworkFileParser & | getParser () const
Public Member Functions inherited from gridfire::DefinedEngineView
| DefinedEngineView (const std::vector< std::string > &peNames, DynamicEngine &baseEngine)
const DynamicEngine & | getBaseEngine () const override
| Access the underlying engine instance.
const std::vector< fourdst::atomic::Species > & | getNetworkSpecies () const override
| Gets the list of active species in the network defined by the file.
std::expected< StepDerivatives< double >, expectations::StaleEngineError > | calculateRHSAndEnergy (const fourdst::composition::Composition &comp, double T9, double rho) const override
| Calculates the right-hand side (dY/dt) and energy generation for the active species.
EnergyDerivatives | calculateEpsDerivatives (const fourdst::composition::Composition &comp, double T9, double rho) const override
| Calculate the derivatives of the energy generation rate with respect to T and rho.
void | generateJacobianMatrix (const fourdst::composition::Composition &comp, const double T9, const double rho) const override
| Generates the Jacobian matrix for the active species.
double | getJacobianMatrixEntry (const fourdst::atomic::Species &rowSpecies, const fourdst::atomic::Species &colSpecies) const override
| Gets an entry from the Jacobian matrix for the active species.
void | generateStoichiometryMatrix () override
| Generates the stoichiometry matrix for the active reactions and species.
int | getStoichiometryMatrixEntry (const fourdst::atomic::Species &species, const reaction::Reaction &reaction) const override
| Gets an entry from the stoichiometry matrix for the active species and reactions.
double | calculateMolarReactionFlow (const reaction::Reaction &reaction, const fourdst::composition::Composition &comp, double T9, double rho) const override
| Calculates the molar reaction flow for a given reaction in the active network.
const reaction::ReactionSet & | getNetworkReactions () const override
| Gets the set of active logical reactions in the network.
void | setNetworkReactions (const reaction::ReactionSet &reactions) override
std::expected< std::unordered_map< fourdst::atomic::Species, double >, expectations::StaleEngineError > | getSpeciesTimescales (const fourdst::composition::Composition &comp, double T9, double rho) const override
| Computes timescales for all active species in the network.
std::expected< std::unordered_map< fourdst::atomic::Species, double >, expectations::StaleEngineError > | getSpeciesDestructionTimescales (const fourdst::composition::Composition &comp, double T9, double rho) const override
fourdst::composition::Composition | update (const NetIn &netIn) override
| Updates the engine view if it is marked as stale.
bool | isStale (const NetIn &netIn) override
void | setScreeningModel (screening::ScreeningType model) override
| Sets the screening model for the base engine.
screening::ScreeningType | getScreeningModel () const override
| Gets the screening model from the base engine.
size_t | getSpeciesIndex (const fourdst::atomic::Species &species) const override
| Get the index of a species in the network.
std::vector< double > | mapNetInToMolarAbundanceVector (const NetIn &netIn) const override
| Map a NetIn object to a vector of molar abundances.
PrimingReport | primeEngine (const NetIn &netIn) override
| Prime the engine with initial conditions.
Public Member Functions inherited from gridfire::DynamicEngine
virtual void | generateJacobianMatrix (const fourdst::composition::Composition &comp, double T9, double rho, const SparsityPattern &sparsityPattern) const
virtual BuildDepthType | getDepth () const
| Get the depth of the network.
virtual void | rebuild (const fourdst::composition::Composition &comp, BuildDepthType depth)
| Rebuild the network with a specified depth.
Public Member Functions inherited from gridfire::Engine
virtual | ~Engine ()=default
| Virtual destructor.
Public Member Functions inherited from gridfire::EngineView< DynamicEngine >
virtual | ~EngineView ()=default
| Virtual destructor.

## Private Types

using | Config = fourdst::config::Config
using | LogManager = fourdst::logging::LogManager

## Private Attributes

Config & | m_config = Config::getInstance()
quill::Logger * | m_logger = LogManager::getInstance().getLogger("log")
std::string | m_fileName
| Parser for the network file.
const io::NetworkFileParser & | m_parser

## Additional Inherited Members

Protected Attributes inherited from gridfire::DefinedEngineView
bool | m_isStale = true
DynamicEngine & | m_baseEngine

## Member Typedef Documentation

## Config

using gridfire::FileDefinedEngineView::Config = fourdst::config::Config

private

## LogManager

using gridfire::FileDefinedEngineView::LogManager = fourdst::logging::LogManager

private

## Constructor & Destructor Documentation

## FileDefinedEngineView()

gridfire::FileDefinedEngineView::FileDefinedEngineView | ( | DynamicEngine & | baseEngine,
|  | const std::string & | fileName,
|  | const io::NetworkFileParser & | parser )

explicit

FileDefinedEngineView Implementation ///.

## Member Function Documentation

## getNetworkFile()

std::string gridfire::FileDefinedEngineView::getNetworkFile | ( |  | ) | const

inlinenodiscard

## getParser()

const io::NetworkFileParser & gridfire::FileDefinedEngineView::getParser | ( |  | ) | const

inlinenodiscard

## Member Data Documentation

## m_config

Config& gridfire::FileDefinedEngineView::m_config = Config::getInstance()

private

## m_fileName

std::string gridfire::FileDefinedEngineView::m_fileName

private

Parser for the network file.

## m_logger

quill::Logger* gridfire::FileDefinedEngineView::m_logger = LogManager::getInstance().getLogger("log")

private

## m_parser

const io::NetworkFileParser& gridfire::FileDefinedEngineView::m_parser

private

The documentation for this class was generated from the following files:

- src/include/gridfire/engine/views/engine_defined.h
- src/lib/engine/views/engine_defined.cpp